import * as React from 'react';
import { ComponentType, LazyExoticComponent, ReactChild, ReactElement, JSXElementConstructor, FunctionComponentElement } from 'react';

interface LazyFactory<T extends ComponentType<any>> extends LazyFactoryMeta {
    (): Promise<{
        default: T;
    }>;
}
interface LazyFactoryMeta {
    chunk?: string;
    lazyImport?: string;
    sync?: true;
}

declare function createLazy(realReact: typeof React): <T extends ComponentType<any>>(factory: LazyFactory<T>) => LazyExoticComponent<T> | (<P extends {}>(props: P, ...children: ReactChild[]) => ReactElement<{}, string | JSXElementConstructor<any>> | FunctionComponentElement<{}>);

export { createLazy };
